#version 400
 
in VertexData {
    vec3 normal;
    vec4 ecPos;
    mat4 m4_inv;
} VertexIn;
 
uniform vec3 L_pos;
uniform vec4 diffuse_col;
uniform mat4 rotation4;

uniform sampler2D tex;

uniform int pass_number;


uniform float angle;

layout(location = 0) out vec4 colorOut;

 
void main()
{

    vec4 color = vec4(1.0, 0.0, 0.0, 1.0);

    //first pass - texture creation
    if (pass_number == 1) {
      // Compute the ligt direction
      vec3 lightDir = vec3(L_pos - VertexIn.ecPos.xyz);
      
      // Compute the dot product between normal and lightDir 
      float NdotL = max(dot(normalize(VertexIn.normal), normalize(lightDir)), 0.0);  
      
      color = diffuse_col * NdotL;
    }
     
    //second pass 
    if (pass_number == 2) {
     
        float n = 8.0;    
        float a = 0.0;
        mat4 m4 = rotation4;

        //v m4 bude rotacia o mensi uhol ako bola povodna rotacia vrchola
        while(a < (angle - 4.0)) { 
          m4 *= rotation4;
          a += 0.1;
        }
    
    
        //ToDo zrotujte povodny vrchol tentoraz o mensi uhol
        //rotated original position using smaler rotation
        //vec4 prevPos = ...;
        
        //vektor posunu vzhladom na predchadzajuci "frame"
        vec2 velocity = (VertexIn.ecPos.xy - prevPos.xy) / n;
        
        //ToDo vypocitajte texturne suradnice vrchola (v obrazovom priestore) ake
        //mal v predchadzajucom "frame" otocenom o mensi uhol
        //vec2 texCoord = ...

        color = texture2D(tex, texCoord) / n;
       
        for (int i = 1; i < n; ++i, texCoord += velocity)
        {
            //ToDo scitajte farby z textury pozdl vektora posunutia
            // Sample the color buffer along the velocity vector and it to color sum
            //... = ...
        }
        
     
        
     }
    

    colorOut = color;
       
}