#version 400
 
layout(triangles) in;
layout (triangle_strip, max_vertices=12) out;
 
in VertexData {
    vec3 normal;
    vec4 ecPos;
    mat4 m4_inv;
} VertexIn[3];
 
out VertexData {
    vec3 normal;
    vec4 ecPos;
    mat4 m4_inv;
} VertexOut;
 
 void main()
{
  
  vec4 center = vec4(0.0, 0.0, 0.0, 0.0);
  
  for(int i = gl_in.length() - 1; i >= 0; i--)
  {
    center += gl_in[i].gl_Position;
    
     // copy attributes
    gl_Position = gl_in[i].gl_Position;
    VertexOut.normal = -VertexIn[i].normal;
    VertexOut.ecPos = VertexIn[i].ecPos;
    VertexOut.m4_inv = VertexIn[0].m4_inv;
   
 
    // done with the vertex
    EmitVertex(); 
    
  }
  
  EndPrimitive();
    
  center /= 3.0;
  
  vec3 v1 = gl_in[1].gl_Position.xyz/gl_in[1].gl_Position.w - gl_in[0].gl_Position.xyz/gl_in[0].gl_Position.w;
  vec3 v2 = gl_in[1].gl_Position.xyz/gl_in[1].gl_Position.w - gl_in[2].gl_Position.xyz/gl_in[2].gl_Position.w;
  
  vec3 v = normalize(cross(v1, v2)) * 0.5;
  
  vec3 a = gl_in[0].gl_Position.xyz/gl_in[0].gl_Position.w; 
  vec3 b = gl_in[1].gl_Position.xyz/gl_in[1].gl_Position.w; 
  vec3 c = gl_in[2].gl_Position.xyz/gl_in[2].gl_Position.w; 
  vec3 d = center.xyz/center.w + v; 
  
  
   //////////////////////////////////////////////////////////
  //abd  
  vec3 n = normalize(cross(d-b, a-b));
  
  // set attributes
  gl_Position = gl_in[0].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[0].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;

 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = gl_in[1].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[1].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;

 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = vec4(d , 1.0);
  VertexOut.normal = n;
  VertexOut.ecPos = vec4(d , 1.0);
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
 
  // done with the vertex
  EmitVertex();
 
  EndPrimitive();
  ///////////////////////////////////////////////////////////////////
  //bcd
  n = normalize(cross(d-c, b-c));
  
  // set attributes
  gl_Position = gl_in[1].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[1].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = gl_in[2].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[2].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = vec4(d , 1.0);
  VertexOut.normal = n;
  VertexOut.ecPos = vec4(d , 1.0);
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
 
  EndPrimitive();
  ////////////////////////////////////////////////////////
  //cad
  n = normalize(cross(d-a, c-a));
  
  // set attributes
  gl_Position = gl_in[2].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[2].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = gl_in[0].gl_Position;
  VertexOut.normal = n;
  VertexOut.ecPos = VertexIn[0].ecPos;
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
  
    // set attributes
  gl_Position = vec4(d , 1.0);
  VertexOut.normal = n;
  VertexOut.ecPos = vec4(d , 1.0);
  VertexOut.m4_inv = VertexIn[0].m4_inv;
 
  // done with the vertex
  EmitVertex();
 
  EndPrimitive();
  
  
}